package eu.eudat.data.query.definition;

import eu.eudat.data.dao.criteria.Criteria;
import eu.eudat.queryable.QueryableList;
import eu.eudat.queryable.queryableentity.DataEntity;

public abstract class Query<C extends Criteria<T>, T extends DataEntity<T, K>, K> implements CriteriaQuery<C, T, K> {
    private C criteria;
    private QueryableList<T> query;

    public QueryableList<T> getQuery() {
        return query;
    }

    public void setQuery(QueryableList<T> query) {
        this.query = query;
    }

    public C getCriteria() {
        return criteria;
    }

    public void setCriteria(C criteria) {
        this.criteria = criteria;
    }

    @Override
    public QueryableList<T> collect() {
        return this.applyCriteria();
    }
}
